/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.IDResolver;
/*     */ import com.sun.xml.bind.unmarshaller.DOMScanner;
/*     */ import com.sun.xml.bind.unmarshaller.InfosetScanner;
/*     */ import com.sun.xml.bind.unmarshaller.Messages;
/*     */ import com.sun.xml.bind.v2.runtime.AssociationMap;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.PropertyException;
/*     */ import javax.xml.bind.UnmarshalException;
/*     */ import javax.xml.bind.Unmarshaller.Listener;
/*     */ import javax.xml.bind.UnmarshallerHandler;
/*     */ import javax.xml.bind.ValidationEvent;
/*     */ import javax.xml.bind.ValidationEventHandler;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import javax.xml.bind.attachment.AttachmentUnmarshaller;
/*     */ import javax.xml.bind.helpers.AbstractUnmarshallerImpl;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamReader;
/*     */ import javax.xml.stream.events.XMLEvent;
/*     */ import javax.xml.transform.Source;
/*     */ import javax.xml.transform.dom.DOMSource;
/*     */ import javax.xml.transform.sax.SAXSource;
/*     */ import javax.xml.transform.stream.StreamSource;
/*     */ import javax.xml.validation.Schema;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.InputSource;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.XMLReader;
/*     */ import org.xml.sax.helpers.DefaultHandler;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class UnmarshallerImpl
/*     */   extends AbstractUnmarshallerImpl
/*     */   implements ValidationEventHandler
/*     */ {
/*     */   protected final JAXBContextImpl context;
/*     */   private Schema schema;
/*     */   public final UnmarshallingContext coordinator;
/*     */   private Unmarshaller.Listener externalListener;
/*     */   private AttachmentUnmarshaller attachmentUnmarshaller;
/*  94 */   private IDResolver idResolver = new DefaultIDResolver();
/*     */   
/*     */   public UnmarshallerImpl(JAXBContextImpl context, AssociationMap assoc) {
/*  97 */     this.context = context;
/*  98 */     this.coordinator = new UnmarshallingContext(this, assoc);
/*     */     try
/*     */     {
/* 101 */       setEventHandler(this);
/*     */     } catch (JAXBException e) {
/* 103 */       throw new AssertionError(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public UnmarshallerHandler getUnmarshallerHandler() {
/* 108 */     return getUnmarshallerHandler(true, null);
/*     */   }
/*     */   
/*     */   private SAXConnector getUnmarshallerHandler(boolean intern, JaxBeanInfo expectedType) {
/* 112 */     XmlVisitor h = createUnmarshallerHandler(null, false, expectedType);
/* 113 */     if (intern)
/* 114 */       h = new InterningXmlVisitor(h);
/* 115 */     return new SAXConnector(h, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final XmlVisitor createUnmarshallerHandler(InfosetScanner scanner, boolean inplace, JaxBeanInfo expectedType)
/*     */   {
/* 133 */     this.coordinator.reset(scanner, inplace, expectedType, this.idResolver);
/* 134 */     XmlVisitor unmarshaller = this.coordinator;
/*     */     
/*     */ 
/* 137 */     if (this.schema != null) {
/* 138 */       unmarshaller = new ValidatingUnmarshaller(this.schema, unmarshaller);
/*     */     }
/* 140 */     if ((this.attachmentUnmarshaller != null) && (this.attachmentUnmarshaller.isXOPPackage())) {
/* 141 */       unmarshaller = new MTOMDecorator(this, unmarshaller, this.attachmentUnmarshaller);
/*     */     }
/* 143 */     return unmarshaller;
/*     */   }
/*     */   
/* 146 */   private static final DefaultHandler dummyHandler = new DefaultHandler();
/*     */   public static final String FACTORY = "com.sun.xml.bind.ObjectFactory";
/*     */   
/*     */   public static boolean needsInterning(XMLReader reader) {
/*     */     try {
/* 151 */       reader.setFeature("http://xml.org/sax/features/string-interning", true);
/*     */     }
/*     */     catch (SAXException e) {}
/*     */     
/*     */     try
/*     */     {
/* 157 */       if (reader.getFeature("http://xml.org/sax/features/string-interning")) {
/* 158 */         return false;
/*     */       }
/*     */     }
/*     */     catch (SAXException e) {}
/*     */     
/* 163 */     return true;
/*     */   }
/*     */   
/*     */   protected Object unmarshal(XMLReader reader, InputSource source) throws JAXBException {
/* 167 */     return unmarshal0(reader, source, null);
/*     */   }
/*     */   
/*     */   protected <T> JAXBElement<T> unmarshal(XMLReader reader, InputSource source, Class<T> expectedType) throws JAXBException {
/* 171 */     if (expectedType == null)
/* 172 */       throw new IllegalArgumentException();
/* 173 */     return (JAXBElement)unmarshal0(reader, source, getBeanInfo(expectedType));
/*     */   }
/*     */   
/*     */   private Object unmarshal0(XMLReader reader, InputSource source, JaxBeanInfo expectedType) throws JAXBException {
/* 177 */     SAXConnector connector = getUnmarshallerHandler(needsInterning(reader), expectedType);
/*     */     
/* 179 */     reader.setContentHandler(connector);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 191 */     reader.setErrorHandler(this.coordinator);
/*     */     try
/*     */     {
/* 194 */       reader.parse(source);
/*     */     } catch (IOException e) {
/* 196 */       throw new UnmarshalException(e);
/*     */     } catch (SAXException e) {
/* 198 */       throw createUnmarshalException(e);
/*     */     }
/*     */     
/* 201 */     Object result = connector.getResult();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 206 */     reader.setContentHandler(dummyHandler);
/* 207 */     reader.setErrorHandler(dummyHandler);
/*     */     
/* 209 */     return result;
/*     */   }
/*     */   
/*     */   public <T> JAXBElement<T> unmarshal(Source source, Class<T> expectedType) throws JAXBException
/*     */   {
/* 214 */     if ((source instanceof SAXSource)) {
/* 215 */       SAXSource ss = (SAXSource)source;
/*     */       
/* 217 */       XMLReader reader = ss.getXMLReader();
/* 218 */       if (reader == null) {
/* 219 */         reader = getXMLReader();
/*     */       }
/* 221 */       return unmarshal(reader, ss.getInputSource(), expectedType);
/*     */     }
/* 223 */     if ((source instanceof StreamSource)) {
/* 224 */       return unmarshal(getXMLReader(), streamSourceToInputSource((StreamSource)source), expectedType);
/*     */     }
/* 226 */     if ((source instanceof DOMSource)) {
/* 227 */       return unmarshal(((DOMSource)source).getNode(), expectedType);
/*     */     }
/*     */     
/* 230 */     throw new IllegalArgumentException();
/*     */   }
/*     */   
/*     */   public Object unmarshal0(Source source, JaxBeanInfo expectedType) throws JAXBException {
/* 234 */     if ((source instanceof SAXSource)) {
/* 235 */       SAXSource ss = (SAXSource)source;
/*     */       
/* 237 */       XMLReader reader = ss.getXMLReader();
/* 238 */       if (reader == null) {
/* 239 */         reader = getXMLReader();
/*     */       }
/* 241 */       return unmarshal0(reader, ss.getInputSource(), expectedType);
/*     */     }
/* 243 */     if ((source instanceof StreamSource)) {
/* 244 */       return unmarshal0(getXMLReader(), streamSourceToInputSource((StreamSource)source), expectedType);
/*     */     }
/* 246 */     if ((source instanceof DOMSource)) {
/* 247 */       return unmarshal0(((DOMSource)source).getNode(), expectedType);
/*     */     }
/*     */     
/* 250 */     throw new IllegalArgumentException();
/*     */   }
/*     */   
/*     */   public final ValidationEventHandler getEventHandler()
/*     */   {
/*     */     try {
/* 256 */       return super.getEventHandler();
/*     */     }
/*     */     catch (JAXBException e) {
/* 259 */       throw new AssertionError();
/*     */     }
/*     */   }
/*     */   
/*     */   public <T> JAXBElement<T> unmarshal(Node node, Class<T> expectedType) throws JAXBException
/*     */   {
/* 265 */     if (expectedType == null)
/* 266 */       throw new IllegalArgumentException();
/* 267 */     return (JAXBElement)unmarshal0(node, getBeanInfo(expectedType));
/*     */   }
/*     */   
/*     */   public final Object unmarshal(Node node) throws JAXBException {
/* 271 */     return unmarshal0(node, null);
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public final Object unmarshal(SAXSource source) throws JAXBException
/*     */   {
/* 277 */     return super.unmarshal(source);
/*     */   }
/*     */   
/*     */   public final Object unmarshal0(Node node, JaxBeanInfo expectedType) throws JAXBException {
/*     */     try {
/* 282 */       DOMScanner scanner = new DOMScanner();
/*     */       
/* 284 */       InterningXmlVisitor handler = new InterningXmlVisitor(createUnmarshallerHandler(null, false, expectedType));
/* 285 */       scanner.setContentHandler(new SAXConnector(handler, scanner));
/*     */       
/* 287 */       if ((node instanceof Element)) {
/* 288 */         scanner.scan((Element)node);
/*     */       }
/* 290 */       else if ((node instanceof Document)) {
/* 291 */         scanner.scan((Document)node);
/*     */       }
/*     */       else {
/* 294 */         throw new IllegalArgumentException();
/*     */       }
/* 296 */       return handler.getContext().getResult();
/*     */     } catch (SAXException e) {
/* 298 */       throw createUnmarshalException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public Object unmarshal(XMLStreamReader reader) throws JAXBException
/*     */   {
/* 304 */     return unmarshal0(reader, null);
/*     */   }
/*     */   
/*     */   public <T> JAXBElement<T> unmarshal(XMLStreamReader reader, Class<T> expectedType) throws JAXBException
/*     */   {
/* 309 */     if (expectedType == null)
/* 310 */       throw new IllegalArgumentException();
/* 311 */     return (JAXBElement)unmarshal0(reader, getBeanInfo(expectedType));
/*     */   }
/*     */   
/*     */   public Object unmarshal0(XMLStreamReader reader, JaxBeanInfo expectedType) throws JAXBException {
/* 315 */     if (reader == null) {
/* 316 */       throw new IllegalArgumentException(Messages.format("Unmarshaller.NullReader"));
/*     */     }
/*     */     
/*     */ 
/* 320 */     int eventType = reader.getEventType();
/* 321 */     if ((eventType != 1) && (eventType != 7))
/*     */     {
/*     */ 
/* 324 */       throw new IllegalStateException(Messages.format("Unmarshaller.IllegalReaderState", Integer.valueOf(eventType)));
/*     */     }
/*     */     
/*     */ 
/* 328 */     XmlVisitor h = createUnmarshallerHandler(null, false, expectedType);
/* 329 */     StAXConnector connector = StAXStreamConnector.create(reader, h);
/*     */     try
/*     */     {
/* 332 */       connector.bridge();
/*     */     } catch (XMLStreamException e) {
/* 334 */       throw handleStreamException(e);
/*     */     }
/*     */     
/* 337 */     return h.getContext().getResult();
/*     */   }
/*     */   
/*     */   public <T> JAXBElement<T> unmarshal(XMLEventReader reader, Class<T> expectedType) throws JAXBException
/*     */   {
/* 342 */     if (expectedType == null)
/* 343 */       throw new IllegalArgumentException();
/* 344 */     return (JAXBElement)unmarshal0(reader, getBeanInfo(expectedType));
/*     */   }
/*     */   
/*     */   public Object unmarshal(XMLEventReader reader) throws JAXBException
/*     */   {
/* 349 */     return unmarshal0(reader, null);
/*     */   }
/*     */   
/*     */   private Object unmarshal0(XMLEventReader reader, JaxBeanInfo expectedType) throws JAXBException {
/* 353 */     if (reader == null) {
/* 354 */       throw new IllegalArgumentException(Messages.format("Unmarshaller.NullReader"));
/*     */     }
/*     */     
/*     */     try
/*     */     {
/* 359 */       XMLEvent event = reader.peek();
/*     */       
/* 361 */       if ((!event.isStartElement()) && (!event.isStartDocument()))
/*     */       {
/* 363 */         throw new IllegalStateException(Messages.format("Unmarshaller.IllegalReaderState", Integer.valueOf(event.getEventType())));
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 369 */       boolean isZephyr = reader.getClass().getName().equals("com.sun.xml.stream.XMLReaderImpl");
/* 370 */       XmlVisitor h = createUnmarshallerHandler(null, false, expectedType);
/* 371 */       if (!isZephyr)
/* 372 */         h = new InterningXmlVisitor(h);
/* 373 */       new StAXEventConnector(reader, h).bridge();
/* 374 */       return h.getContext().getResult();
/*     */     } catch (XMLStreamException e) {
/* 376 */       throw handleStreamException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public Object unmarshal0(InputStream input, JaxBeanInfo expectedType) throws JAXBException {
/* 381 */     return unmarshal0(getXMLReader(), new InputSource(input), expectedType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static JAXBException handleStreamException(XMLStreamException e)
/*     */   {
/* 391 */     Throwable ne = e.getNestedException();
/* 392 */     if ((ne instanceof JAXBException))
/* 393 */       return (JAXBException)ne;
/* 394 */     if ((ne instanceof SAXException))
/* 395 */       return new UnmarshalException(ne);
/* 396 */     return new UnmarshalException(e);
/*     */   }
/*     */   
/*     */   public Object getProperty(String name) throws PropertyException {
/* 400 */     if (name.equals(IDResolver.class.getName())) {
/* 401 */       return this.idResolver;
/*     */     }
/* 403 */     return super.getProperty(name);
/*     */   }
/*     */   
/*     */   public void setProperty(String name, Object value) throws PropertyException {
/* 407 */     if (name.equals("com.sun.xml.bind.ObjectFactory")) {
/* 408 */       this.coordinator.setFactories(value);
/* 409 */       return;
/*     */     }
/* 411 */     if (name.equals(IDResolver.class.getName())) {
/* 412 */       this.idResolver = ((IDResolver)value);
/* 413 */       return;
/*     */     }
/* 415 */     super.setProperty(name, value);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setSchema(Schema schema)
/*     */   {
/* 422 */     this.schema = schema;
/*     */   }
/*     */   
/*     */   public Schema getSchema()
/*     */   {
/* 427 */     return this.schema;
/*     */   }
/*     */   
/*     */   public AttachmentUnmarshaller getAttachmentUnmarshaller()
/*     */   {
/* 432 */     return this.attachmentUnmarshaller;
/*     */   }
/*     */   
/*     */   public void setAttachmentUnmarshaller(AttachmentUnmarshaller au)
/*     */   {
/* 437 */     this.attachmentUnmarshaller = au;
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public boolean isValidating()
/*     */   {
/* 445 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setValidating(boolean validating)
/*     */   {
/* 453 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public <A extends XmlAdapter> void setAdapter(Class<A> type, A adapter)
/*     */   {
/* 458 */     if (type == null)
/* 459 */       throw new IllegalArgumentException();
/* 460 */     this.coordinator.putAdapter(type, adapter);
/*     */   }
/*     */   
/*     */   public <A extends XmlAdapter> A getAdapter(Class<A> type)
/*     */   {
/* 465 */     if (type == null)
/* 466 */       throw new IllegalArgumentException();
/* 467 */     if (this.coordinator.containsAdapter(type))
/*     */     {
/* 469 */       return this.coordinator.getAdapter(type);
/*     */     }
/* 471 */     return null;
/*     */   }
/*     */   
/*     */   public UnmarshalException createUnmarshalException(SAXException e)
/*     */   {
/* 476 */     return super.createUnmarshalException(e);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean handleEvent(ValidationEvent event)
/*     */   {
/* 484 */     return event.getSeverity() != 2;
/*     */   }
/*     */   
/*     */   private static InputSource streamSourceToInputSource(StreamSource ss) {
/* 488 */     InputSource is = new InputSource();
/* 489 */     is.setSystemId(ss.getSystemId());
/* 490 */     is.setByteStream(ss.getInputStream());
/* 491 */     is.setCharacterStream(ss.getReader());
/*     */     
/* 493 */     return is;
/*     */   }
/*     */   
/*     */   public <T> JaxBeanInfo<T> getBeanInfo(Class<T> clazz) throws JAXBException {
/* 497 */     return this.context.getBeanInfo(clazz, true);
/*     */   }
/*     */   
/*     */   public Unmarshaller.Listener getListener()
/*     */   {
/* 502 */     return this.externalListener;
/*     */   }
/*     */   
/*     */   public void setListener(Unmarshaller.Listener listener)
/*     */   {
/* 507 */     this.externalListener = listener;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\UnmarshallerImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */