/*     */ package com.sun.xml.txw2.output;
/*     */ 
/*     */ import java.io.Writer;
/*     */ import java.util.Stack;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DataWriter
/*     */   extends XMLWriter
/*     */ {
/*     */   public DataWriter(Writer writer, String encoding, CharacterEscapeHandler _escapeHandler)
/*     */   {
/*  94 */     super(writer, encoding, _escapeHandler);
/*     */   }
/*     */   
/*     */   public DataWriter(Writer writer, String encoding)
/*     */   {
/*  99 */     this(writer, encoding, DumbEscapeHandler.theInstance);
/*     */   }
/*     */   
/*     */   public DataWriter(Writer writer) {
/* 103 */     this(writer, null, DumbEscapeHandler.theInstance);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public int getIndentStep()
/*     */   {
/* 129 */     return this.indentStep.length();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setIndentStep(int indentStep)
/*     */   {
/* 145 */     String s = "";
/* 146 */     for (; indentStep > 0; indentStep--) s = s + ' ';
/* 147 */     setIndentStep(s);
/*     */   }
/*     */   
/*     */   public void setIndentStep(String s) {
/* 151 */     this.indentStep = s;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void reset()
/*     */   {
/* 171 */     this.depth = 0;
/* 172 */     this.state = SEEN_NOTHING;
/* 173 */     this.stateStack = new Stack();
/* 174 */     super.reset();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startElement(String uri, String localName, String qName, Attributes atts)
/*     */     throws SAXException
/*     */   {
/* 201 */     this.stateStack.push(SEEN_ELEMENT);
/* 202 */     this.state = SEEN_NOTHING;
/* 203 */     if (this.depth > 0) {
/* 204 */       super.characters("\n");
/*     */     }
/* 206 */     doIndent();
/* 207 */     super.startElement(uri, localName, qName, atts);
/* 208 */     this.depth += 1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endElement(String uri, String localName, String qName)
/*     */     throws SAXException
/*     */   {
/* 233 */     this.depth -= 1;
/* 234 */     if (this.state == SEEN_ELEMENT) {
/* 235 */       super.characters("\n");
/* 236 */       doIndent();
/*     */     }
/* 238 */     super.endElement(uri, localName, qName);
/* 239 */     this.state = this.stateStack.pop();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void characters(char[] ch, int start, int length)
/*     */     throws SAXException
/*     */   {
/* 289 */     this.state = SEEN_DATA;
/* 290 */     super.characters(ch, start, length);
/*     */   }
/*     */   
/*     */   public void comment(char[] ch, int start, int length) throws SAXException {
/* 294 */     if (this.depth > 0) {
/* 295 */       super.characters("\n");
/*     */     }
/* 297 */     doIndent();
/* 298 */     super.comment(ch, start, length);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void doIndent()
/*     */     throws SAXException
/*     */   {
/* 318 */     if (this.depth > 0) {
/* 319 */       char[] ch = this.indentStep.toCharArray();
/* 320 */       for (int i = 0; i < this.depth; i++) {
/* 321 */         characters(ch, 0, ch.length);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 331 */   private static final Object SEEN_NOTHING = new Object();
/* 332 */   private static final Object SEEN_ELEMENT = new Object();
/* 333 */   private static final Object SEEN_DATA = new Object();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 341 */   private Object state = SEEN_NOTHING;
/* 342 */   private Stack stateStack = new Stack();
/*     */   
/* 344 */   private String indentStep = "";
/* 345 */   private int depth = 0;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\output\DataWriter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */