/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.LinkedList;
/*     */ import java.util.NoSuchElementException;
/*     */ import java.util.Queue;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import java.util.concurrent.TimeUnit;
/*     */ import java.util.concurrent.TimeoutException;
/*     */ import net.rubyeye.xmemcached.KeyIterator;
/*     */ import net.rubyeye.xmemcached.XMemcachedClient;
/*     */ import net.rubyeye.xmemcached.command.text.TextCacheDumpCommand;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedException;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedServerException;
/*     */ import net.rubyeye.xmemcached.networking.Connector;
/*     */ import net.rubyeye.xmemcached.utils.Protocol;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class KeyIteratorImpl
/*     */   implements KeyIterator
/*     */ {
/*     */   private final LinkedList<Integer> itemNumbersList;
/*     */   private LinkedList<String> currentKeyList;
/*     */   private final XMemcachedClient memcachedClient;
/*     */   private final InetSocketAddress inetSocketAddress;
/*  31 */   private long opTimeout = 1000L;
/*     */   
/*     */ 
/*     */ 
/*     */   public KeyIteratorImpl(LinkedList<Integer> itemNumbersList, XMemcachedClient memcachedClient, InetSocketAddress inetSocketAddress)
/*     */   {
/*  37 */     this.itemNumbersList = itemNumbersList;
/*  38 */     this.memcachedClient = memcachedClient;
/*  39 */     this.inetSocketAddress = inetSocketAddress;
/*     */   }
/*     */   
/*     */   public final InetSocketAddress getServerAddress() {
/*  43 */     return this.inetSocketAddress;
/*     */   }
/*     */   
/*     */   public final void setOpTimeout(long opTimeout) {
/*  47 */     this.opTimeout = opTimeout;
/*     */   }
/*     */   
/*     */   public void close() {
/*  51 */     this.itemNumbersList.clear();
/*  52 */     this.currentKeyList.clear();
/*  53 */     this.currentKeyList = null;
/*     */   }
/*     */   
/*     */   public boolean hasNext() {
/*  57 */     return ((this.itemNumbersList != null) && (!this.itemNumbersList.isEmpty())) || ((this.currentKeyList != null) && (!this.currentKeyList.isEmpty()));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String next()
/*     */     throws MemcachedException, TimeoutException, InterruptedException
/*     */   {
/*  65 */     if (!hasNext()) {
/*  66 */       throw new NoSuchElementException();
/*     */     }
/*     */     
/*  69 */     if ((this.currentKeyList != null) && (!this.currentKeyList.isEmpty())) {
/*  70 */       return (String)this.currentKeyList.remove();
/*     */     }
/*     */     
/*  73 */     int itemNumber = ((Integer)this.itemNumbersList.remove()).intValue();
/*  74 */     Queue<Session> sessions = this.memcachedClient.getConnector().getSessionByAddress(this.inetSocketAddress);
/*     */     
/*  76 */     if ((sessions == null) || (sessions.size() == 0)) {
/*  77 */       throw new MemcachedException("The memcached server is not connected,address=" + this.inetSocketAddress);
/*     */     }
/*     */     
/*     */ 
/*  81 */     Session session = (Session)sessions.peek();
/*  82 */     CountDownLatch latch = new CountDownLatch(1);
/*  83 */     if (this.memcachedClient.getProtocol() == Protocol.Text) {
/*  84 */       TextCacheDumpCommand textCacheDumpCommand = new TextCacheDumpCommand(latch, itemNumber);
/*     */       
/*  86 */       session.write(textCacheDumpCommand);
/*  87 */       if (!latch.await(this.opTimeout, TimeUnit.MILLISECONDS)) {
/*  88 */         throw new TimeoutException("stats cachedump timeout");
/*     */       }
/*  90 */       if (textCacheDumpCommand.getException() != null) {
/*  91 */         if ((textCacheDumpCommand.getException() instanceof MemcachedException)) {
/*  92 */           throw ((MemcachedException)textCacheDumpCommand.getException());
/*     */         }
/*     */         
/*  95 */         throw new MemcachedServerException(textCacheDumpCommand.getException());
/*     */       }
/*     */       
/*     */ 
/*  99 */       this.currentKeyList = ((LinkedList)textCacheDumpCommand.getResult());
/*     */     }
/*     */     else {
/* 102 */       throw new MemcachedException(this.memcachedClient.getProtocol().name() + " protocol doesn't support iterating all keys in memcached");
/*     */     }
/*     */     
/*     */ 
/* 106 */     return next();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\KeyIteratorImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */