/*     */ package org.codehaus.jackson.impl;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import org.codehaus.jackson.Base64Variant;
/*     */ import org.codehaus.jackson.JsonParseException;
/*     */ import org.codehaus.jackson.JsonParser;
/*     */ import org.codehaus.jackson.JsonParser.Feature;
/*     */ import org.codehaus.jackson.JsonProcessingException;
/*     */ import org.codehaus.jackson.JsonStreamContext;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ import org.codehaus.jackson.io.NumberInput;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class JsonParserMinimalBase
/*     */   extends JsonParser
/*     */ {
/*     */   protected static final int INT_TAB = 9;
/*     */   protected static final int INT_LF = 10;
/*     */   protected static final int INT_CR = 13;
/*     */   protected static final int INT_SPACE = 32;
/*     */   protected static final int INT_LBRACKET = 91;
/*     */   protected static final int INT_RBRACKET = 93;
/*     */   protected static final int INT_LCURLY = 123;
/*     */   protected static final int INT_RCURLY = 125;
/*     */   protected static final int INT_QUOTE = 34;
/*     */   protected static final int INT_BACKSLASH = 92;
/*     */   protected static final int INT_SLASH = 47;
/*     */   protected static final int INT_COLON = 58;
/*     */   protected static final int INT_COMMA = 44;
/*     */   protected static final int INT_ASTERISK = 42;
/*     */   protected static final int INT_APOSTROPHE = 39;
/*     */   protected static final int INT_b = 98;
/*     */   protected static final int INT_f = 102;
/*     */   protected static final int INT_n = 110;
/*     */   protected static final int INT_r = 114;
/*     */   protected static final int INT_t = 116;
/*     */   protected static final int INT_u = 117;
/*     */   
/*     */   protected JsonParserMinimalBase() {}
/*     */   
/*     */   protected JsonParserMinimalBase(int features)
/*     */   {
/*  56 */     super(features);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JsonToken nextToken()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonParser skipChildren()
/*     */     throws IOException, JsonParseException
/*     */   {
/*  86 */     if ((this._currToken != JsonToken.START_OBJECT) && (this._currToken != JsonToken.START_ARRAY))
/*     */     {
/*  88 */       return this;
/*     */     }
/*  90 */     int open = 1;
/*     */     
/*     */ 
/*     */ 
/*     */     for (;;)
/*     */     {
/*  96 */       JsonToken t = nextToken();
/*  97 */       if (t == null) {
/*  98 */         _handleEOF();
/*     */         
/*     */ 
/*     */ 
/*     */ 
/* 103 */         return this;
/*     */       }
/* 105 */       switch (t) {
/*     */       case START_OBJECT: 
/*     */       case START_ARRAY: 
/* 108 */         open++;
/* 109 */         break;
/*     */       case END_OBJECT: 
/*     */       case END_ARRAY: 
/* 112 */         open--; if (open == 0) {
/* 113 */           return this;
/*     */         }
/*     */         
/*     */ 
/*     */ 
/*     */         break;
/*     */       }
/*     */       
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected abstract void _handleEOF()
/*     */     throws JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String getCurrentName()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void close()
/*     */     throws IOException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract boolean isClosed();
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract JsonStreamContext getParsingContext();
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract String getText()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract char[] getTextCharacters()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract boolean hasTextCharacters();
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract int getTextLength()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract int getTextOffset()
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract byte[] getBinaryValue(Base64Variant paramBase64Variant)
/*     */     throws IOException, JsonParseException;
/*     */   
/*     */ 
/*     */ 
/*     */   public boolean getValueAsBoolean(boolean defaultValue)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 185 */     if (this._currToken != null) {
/* 186 */       switch (this._currToken) {
/*     */       case VALUE_NUMBER_INT: 
/* 188 */         return getIntValue() != 0;
/*     */       case VALUE_TRUE: 
/* 190 */         return true;
/*     */       case VALUE_FALSE: 
/*     */       case VALUE_NULL: 
/* 193 */         return false;
/*     */       
/*     */       case VALUE_EMBEDDED_OBJECT: 
/* 196 */         Object value = getEmbeddedObject();
/* 197 */         if ((value instanceof Boolean)) {
/* 198 */           return ((Boolean)value).booleanValue();
/*     */         }
/*     */       
/*     */       case VALUE_STRING: 
/* 202 */         String str = getText().trim();
/* 203 */         if ("true".equals(str)) {
/* 204 */           return true;
/*     */         }
/*     */         break;
/*     */       }
/*     */     }
/* 209 */     return defaultValue;
/*     */   }
/*     */   
/*     */   public int getValueAsInt(int defaultValue)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 215 */     if (this._currToken != null) {
/* 216 */       switch (this._currToken) {
/*     */       case VALUE_NUMBER_INT: 
/*     */       case VALUE_NUMBER_FLOAT: 
/* 219 */         return getIntValue();
/*     */       case VALUE_TRUE: 
/* 221 */         return 1;
/*     */       case VALUE_FALSE: 
/*     */       case VALUE_NULL: 
/* 224 */         return 0;
/*     */       case VALUE_STRING: 
/* 226 */         return NumberInput.parseAsInt(getText(), defaultValue);
/*     */       
/*     */       case VALUE_EMBEDDED_OBJECT: 
/* 229 */         Object value = getEmbeddedObject();
/* 230 */         if ((value instanceof Number)) {
/* 231 */           return ((Number)value).intValue();
/*     */         }
/*     */         break;
/*     */       }
/*     */     }
/* 236 */     return defaultValue;
/*     */   }
/*     */   
/*     */   public long getValueAsLong(long defaultValue)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 242 */     if (this._currToken != null) {
/* 243 */       switch (this._currToken) {
/*     */       case VALUE_NUMBER_INT: 
/*     */       case VALUE_NUMBER_FLOAT: 
/* 246 */         return getLongValue();
/*     */       case VALUE_TRUE: 
/* 248 */         return 1L;
/*     */       case VALUE_FALSE: 
/*     */       case VALUE_NULL: 
/* 251 */         return 0L;
/*     */       case VALUE_STRING: 
/* 253 */         return NumberInput.parseAsLong(getText(), defaultValue);
/*     */       
/*     */       case VALUE_EMBEDDED_OBJECT: 
/* 256 */         Object value = getEmbeddedObject();
/* 257 */         if ((value instanceof Number)) {
/* 258 */           return ((Number)value).longValue();
/*     */         }
/*     */         break;
/*     */       }
/*     */     }
/* 263 */     return defaultValue;
/*     */   }
/*     */   
/*     */   public double getValueAsDouble(double defaultValue)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 269 */     if (this._currToken != null) {
/* 270 */       switch (this._currToken) {
/*     */       case VALUE_NUMBER_INT: 
/*     */       case VALUE_NUMBER_FLOAT: 
/* 273 */         return getDoubleValue();
/*     */       case VALUE_TRUE: 
/* 275 */         return 1.0D;
/*     */       case VALUE_FALSE: 
/*     */       case VALUE_NULL: 
/* 278 */         return 0.0D;
/*     */       case VALUE_STRING: 
/* 280 */         return NumberInput.parseAsDouble(getText(), defaultValue);
/*     */       
/*     */       case VALUE_EMBEDDED_OBJECT: 
/* 283 */         Object value = getEmbeddedObject();
/* 284 */         if ((value instanceof Number)) {
/* 285 */           return ((Number)value).doubleValue();
/*     */         }
/*     */         break;
/*     */       }
/*     */     }
/* 290 */     return defaultValue;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void _reportUnexpectedChar(int ch, String comment)
/*     */     throws JsonParseException
/*     */   {
/* 302 */     String msg = "Unexpected character (" + _getCharDesc(ch) + ")";
/* 303 */     if (comment != null) {
/* 304 */       msg = msg + ": " + comment;
/*     */     }
/* 306 */     _reportError(msg);
/*     */   }
/*     */   
/*     */   protected void _reportInvalidEOF()
/*     */     throws JsonParseException
/*     */   {
/* 312 */     _reportInvalidEOF(" in " + this._currToken);
/*     */   }
/*     */   
/*     */   protected void _reportInvalidEOF(String msg)
/*     */     throws JsonParseException
/*     */   {
/* 318 */     _reportError("Unexpected end-of-input" + msg);
/*     */   }
/*     */   
/*     */   protected void _reportInvalidEOFInValue() throws JsonParseException
/*     */   {
/* 323 */     _reportInvalidEOF(" in a value");
/*     */   }
/*     */   
/*     */   protected void _throwInvalidSpace(int i)
/*     */     throws JsonParseException
/*     */   {
/* 329 */     char c = (char)i;
/* 330 */     String msg = "Illegal character (" + _getCharDesc(c) + "): only regular white space (\\r, \\n, \\t) is allowed between tokens";
/* 331 */     _reportError(msg);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void _throwUnquotedSpace(int i, String ctxtDesc)
/*     */     throws JsonParseException
/*     */   {
/* 343 */     if ((!isEnabled(JsonParser.Feature.ALLOW_UNQUOTED_CONTROL_CHARS)) || (i >= 32)) {
/* 344 */       char c = (char)i;
/* 345 */       String msg = "Illegal unquoted character (" + _getCharDesc(c) + "): has to be escaped using backslash to be included in " + ctxtDesc;
/* 346 */       _reportError(msg);
/*     */     }
/*     */   }
/*     */   
/*     */   protected char _handleUnrecognizedCharacterEscape(char ch)
/*     */     throws JsonProcessingException
/*     */   {
/* 353 */     if (isEnabled(JsonParser.Feature.ALLOW_BACKSLASH_ESCAPING_ANY_CHARACTER)) {
/* 354 */       return ch;
/*     */     }
/*     */     
/* 357 */     if ((ch == '\'') && (isEnabled(JsonParser.Feature.ALLOW_SINGLE_QUOTES))) {
/* 358 */       return ch;
/*     */     }
/* 360 */     _reportError("Unrecognized character escape " + _getCharDesc(ch));
/* 361 */     return ch;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected static final String _getCharDesc(int ch)
/*     */   {
/* 372 */     char c = (char)ch;
/* 373 */     if (Character.isISOControl(c)) {
/* 374 */       return "(CTRL-CHAR, code " + ch + ")";
/*     */     }
/* 376 */     if (ch > 255) {
/* 377 */       return "'" + c + "' (code " + ch + " / 0x" + Integer.toHexString(ch) + ")";
/*     */     }
/* 379 */     return "'" + c + "' (code " + ch + ")";
/*     */   }
/*     */   
/*     */   protected final void _reportError(String msg)
/*     */     throws JsonParseException
/*     */   {
/* 385 */     throw _constructError(msg);
/*     */   }
/*     */   
/*     */   protected final void _wrapError(String msg, Throwable t)
/*     */     throws JsonParseException
/*     */   {
/* 391 */     throw _constructError(msg, t);
/*     */   }
/*     */   
/*     */   protected final void _throwInternal()
/*     */   {
/* 396 */     throw new RuntimeException("Internal error: this code path should never get executed");
/*     */   }
/*     */   
/*     */   protected final JsonParseException _constructError(String msg, Throwable t)
/*     */   {
/* 401 */     return new JsonParseException(msg, getCurrentLocation(), t);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\impl\JsonParserMinimalBase.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */