/*     */ package org.codehaus.jackson.map.introspect;
/*     */ 
/*     */ import org.codehaus.jackson.annotate.JsonBackReference;
/*     */ import org.codehaus.jackson.annotate.JsonClass;
/*     */ import org.codehaus.jackson.annotate.JsonContentClass;
/*     */ import org.codehaus.jackson.annotate.JsonGetter;
/*     */ import org.codehaus.jackson.annotate.JsonIgnoreProperties;
/*     */ import org.codehaus.jackson.annotate.JsonIgnoreType;
/*     */ import org.codehaus.jackson.annotate.JsonKeyClass;
/*     */ import org.codehaus.jackson.annotate.JsonManagedReference;
/*     */ import org.codehaus.jackson.annotate.JsonProperty;
/*     */ import org.codehaus.jackson.annotate.JsonPropertyOrder;
/*     */ import org.codehaus.jackson.annotate.JsonRawValue;
/*     */ import org.codehaus.jackson.annotate.JsonSetter;
/*     */ import org.codehaus.jackson.annotate.JsonSubTypes;
/*     */ import org.codehaus.jackson.annotate.JsonTypeInfo;
/*     */ import org.codehaus.jackson.annotate.JsonTypeName;
/*     */ import org.codehaus.jackson.annotate.JsonValue;
/*     */ import org.codehaus.jackson.annotate.JsonWriteNullProperties;
/*     */ import org.codehaus.jackson.map.BeanProperty;
/*     */ import org.codehaus.jackson.map.JsonDeserializer;
/*     */ import org.codehaus.jackson.map.JsonSerializer;
/*     */ import org.codehaus.jackson.map.MapperConfig;
/*     */ import org.codehaus.jackson.map.annotate.JsonCachable;
/*     */ import org.codehaus.jackson.map.annotate.JsonDeserialize;
/*     */ import org.codehaus.jackson.map.annotate.JsonFilter;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;
/*     */ import org.codehaus.jackson.map.annotate.JsonTypeIdResolver;
/*     */ import org.codehaus.jackson.map.annotate.JsonTypeResolver;
/*     */ import org.codehaus.jackson.map.annotate.JsonView;
/*     */ import org.codehaus.jackson.map.annotate.NoClass;
/*     */ import org.codehaus.jackson.map.jsontype.TypeResolverBuilder;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ public class JacksonAnnotationIntrospector extends org.codehaus.jackson.map.AnnotationIntrospector
/*     */ {
/*     */   public boolean isHandled(java.lang.annotation.Annotation ann)
/*     */   {
/*  40 */     Class<? extends java.lang.annotation.Annotation> acls = ann.annotationType();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  50 */     return acls.getAnnotation(org.codehaus.jackson.annotate.JacksonAnnotation.class) != null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findEnumValue(Enum<?> value)
/*     */   {
/*  62 */     return value.name();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Boolean findCachability(AnnotatedClass ac)
/*     */   {
/*  74 */     JsonCachable ann = (JsonCachable)ac.getAnnotation(JsonCachable.class);
/*  75 */     if (ann == null) {
/*  76 */       return null;
/*     */     }
/*  78 */     return ann.value() ? Boolean.TRUE : Boolean.FALSE;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String findRootName(AnnotatedClass ac)
/*     */   {
/*  85 */     return null;
/*     */   }
/*     */   
/*     */   public String[] findPropertiesToIgnore(AnnotatedClass ac)
/*     */   {
/*  90 */     JsonIgnoreProperties ignore = (JsonIgnoreProperties)ac.getAnnotation(JsonIgnoreProperties.class);
/*  91 */     return ignore == null ? null : ignore.value();
/*     */   }
/*     */   
/*     */   public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)
/*     */   {
/*  96 */     JsonIgnoreProperties ignore = (JsonIgnoreProperties)ac.getAnnotation(JsonIgnoreProperties.class);
/*  97 */     return ignore == null ? null : Boolean.valueOf(ignore.ignoreUnknown());
/*     */   }
/*     */   
/*     */   public Boolean isIgnorableType(AnnotatedClass ac)
/*     */   {
/* 102 */     JsonIgnoreType ignore = (JsonIgnoreType)ac.getAnnotation(JsonIgnoreType.class);
/* 103 */     return ignore == null ? null : Boolean.valueOf(ignore.value());
/*     */   }
/*     */   
/*     */ 
/*     */   public Object findFilterId(AnnotatedClass ac)
/*     */   {
/* 109 */     JsonFilter ann = (JsonFilter)ac.getAnnotation(JsonFilter.class);
/* 110 */     if (ann != null) {
/* 111 */       String id = ann.value();
/*     */       
/* 113 */       if (id.length() > 0) {
/* 114 */         return id;
/*     */       }
/*     */     }
/* 117 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)
/*     */   {
/* 130 */     org.codehaus.jackson.annotate.JsonAutoDetect ann = (org.codehaus.jackson.annotate.JsonAutoDetect)ac.getAnnotation(org.codehaus.jackson.annotate.JsonAutoDetect.class);
/* 131 */     return ann == null ? checker : checker.with(ann);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public org.codehaus.jackson.map.AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)
/*     */   {
/* 144 */     JsonManagedReference ref1 = (JsonManagedReference)member.getAnnotation(JsonManagedReference.class);
/* 145 */     if (ref1 != null) {
/* 146 */       return org.codehaus.jackson.map.AnnotationIntrospector.ReferenceProperty.managed(ref1.value());
/*     */     }
/* 148 */     JsonBackReference ref2 = (JsonBackReference)member.getAnnotation(JsonBackReference.class);
/* 149 */     if (ref2 != null) {
/* 150 */       return org.codehaus.jackson.map.AnnotationIntrospector.ReferenceProperty.back(ref2.value());
/*     */     }
/* 152 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)
/*     */   {
/* 165 */     return _findTypeResolver(config, ac, baseType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)
/*     */   {
/* 178 */     if (baseType.isContainerType()) { return null;
/*     */     }
/* 180 */     return _findTypeResolver(config, am, baseType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)
/*     */   {
/* 193 */     if (!containerType.isContainerType()) {
/* 194 */       throw new IllegalArgumentException("Must call method with a container type (got " + containerType + ")");
/*     */     }
/* 196 */     return _findTypeResolver(config, am, containerType);
/*     */   }
/*     */   
/*     */ 
/*     */   public java.util.List<org.codehaus.jackson.map.jsontype.NamedType> findSubtypes(Annotated a)
/*     */   {
/* 202 */     JsonSubTypes t = (JsonSubTypes)a.getAnnotation(JsonSubTypes.class);
/* 203 */     if (t == null) return null;
/* 204 */     org.codehaus.jackson.annotate.JsonSubTypes.Type[] types = t.value();
/* 205 */     java.util.ArrayList<org.codehaus.jackson.map.jsontype.NamedType> result = new java.util.ArrayList(types.length);
/* 206 */     for (org.codehaus.jackson.annotate.JsonSubTypes.Type type : types) {
/* 207 */       result.add(new org.codehaus.jackson.map.jsontype.NamedType(type.value(), type.name()));
/*     */     }
/* 209 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */   public String findTypeName(AnnotatedClass ac)
/*     */   {
/* 215 */     JsonTypeName tn = (JsonTypeName)ac.getAnnotation(JsonTypeName.class);
/* 216 */     return tn == null ? null : tn.value();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isIgnorableMethod(AnnotatedMethod m)
/*     */   {
/* 227 */     return _isIgnorable(m);
/*     */   }
/*     */   
/*     */   public boolean isIgnorableConstructor(AnnotatedConstructor c)
/*     */   {
/* 232 */     return _isIgnorable(c);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isIgnorableField(AnnotatedField f)
/*     */   {
/* 243 */     return _isIgnorable(f);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object findSerializer(Annotated a, BeanProperty property)
/*     */   {
/* 258 */     JsonSerialize ann = (JsonSerialize)a.getAnnotation(JsonSerialize.class);
/* 259 */     if (ann != null) {
/* 260 */       Class<? extends JsonSerializer<?>> serClass = ann.using();
/* 261 */       if (serClass != org.codehaus.jackson.map.JsonSerializer.None.class) {
/* 262 */         return serClass;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 270 */     JsonRawValue annRaw = (JsonRawValue)a.getAnnotation(JsonRawValue.class);
/* 271 */     if ((annRaw != null) && (annRaw.value()))
/*     */     {
/* 273 */       Class<?> cls = a.getRawType();
/* 274 */       return new org.codehaus.jackson.map.ser.impl.RawSerializer(cls);
/*     */     }
/* 276 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated a)
/*     */   {
/* 282 */     JsonSerialize ann = (JsonSerialize)a.getAnnotation(JsonSerialize.class);
/* 283 */     if (ann != null) {
/* 284 */       Class<? extends JsonSerializer<?>> serClass = ann.keyUsing();
/* 285 */       if (serClass != org.codehaus.jackson.map.JsonSerializer.None.class) {
/* 286 */         return serClass;
/*     */       }
/*     */     }
/* 289 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated a)
/*     */   {
/* 295 */     JsonSerialize ann = (JsonSerialize)a.getAnnotation(JsonSerialize.class);
/* 296 */     if (ann != null) {
/* 297 */       Class<? extends JsonSerializer<?>> serClass = ann.contentUsing();
/* 298 */       if (serClass != org.codehaus.jackson.map.JsonSerializer.None.class) {
/* 299 */         return serClass;
/*     */       }
/*     */     }
/* 302 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JsonSerialize.Inclusion findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)
/*     */   {
/* 309 */     JsonSerialize ann = (JsonSerialize)a.getAnnotation(JsonSerialize.class);
/* 310 */     if (ann != null) {
/* 311 */       return ann.include();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 316 */     JsonWriteNullProperties oldAnn = (JsonWriteNullProperties)a.getAnnotation(JsonWriteNullProperties.class);
/* 317 */     if (oldAnn != null) {
/* 318 */       boolean writeNulls = oldAnn.value();
/* 319 */       return writeNulls ? JsonSerialize.Inclusion.ALWAYS : JsonSerialize.Inclusion.NON_NULL;
/*     */     }
/* 321 */     return defValue;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> findSerializationType(Annotated am)
/*     */   {
/* 327 */     JsonSerialize ann = (JsonSerialize)am.getAnnotation(JsonSerialize.class);
/* 328 */     if (ann != null) {
/* 329 */       Class<?> cls = ann.as();
/* 330 */       if (cls != NoClass.class) {
/* 331 */         return cls;
/*     */       }
/*     */     }
/* 334 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> findSerializationKeyType(Annotated am, JavaType baseType)
/*     */   {
/* 340 */     JsonSerialize ann = (JsonSerialize)am.getAnnotation(JsonSerialize.class);
/* 341 */     if (ann != null) {
/* 342 */       Class<?> cls = ann.keyAs();
/* 343 */       if (cls != NoClass.class) {
/* 344 */         return cls;
/*     */       }
/*     */     }
/* 347 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> findSerializationContentType(Annotated am, JavaType baseType)
/*     */   {
/* 353 */     JsonSerialize ann = (JsonSerialize)am.getAnnotation(JsonSerialize.class);
/* 354 */     if (ann != null) {
/* 355 */       Class<?> cls = ann.contentAs();
/* 356 */       if (cls != NoClass.class) {
/* 357 */         return cls;
/*     */       }
/*     */     }
/* 360 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public org.codehaus.jackson.map.annotate.JsonSerialize.Typing findSerializationTyping(Annotated a)
/*     */   {
/* 366 */     JsonSerialize ann = (JsonSerialize)a.getAnnotation(JsonSerialize.class);
/* 367 */     return ann == null ? null : ann.typing();
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?>[] findSerializationViews(Annotated a)
/*     */   {
/* 373 */     JsonView ann = (JsonView)a.getAnnotation(JsonView.class);
/* 374 */     return ann == null ? null : ann.value();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String[] findSerializationPropertyOrder(AnnotatedClass ac)
/*     */   {
/* 385 */     JsonPropertyOrder order = (JsonPropertyOrder)ac.getAnnotation(JsonPropertyOrder.class);
/* 386 */     return order == null ? null : order.value();
/*     */   }
/*     */   
/*     */   public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)
/*     */   {
/* 391 */     JsonPropertyOrder order = (JsonPropertyOrder)ac.getAnnotation(JsonPropertyOrder.class);
/* 392 */     return order == null ? null : Boolean.valueOf(order.alphabetic());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findGettablePropertyName(AnnotatedMethod am)
/*     */   {
/* 408 */     JsonProperty pann = (JsonProperty)am.getAnnotation(JsonProperty.class);
/* 409 */     if (pann != null) {
/* 410 */       return pann.value();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 415 */     JsonGetter ann = (JsonGetter)am.getAnnotation(JsonGetter.class);
/* 416 */     if (ann != null) {
/* 417 */       return ann.value();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 423 */     if ((am.hasAnnotation(JsonSerialize.class)) || (am.hasAnnotation(JsonView.class))) {
/* 424 */       return "";
/*     */     }
/* 426 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean hasAsValueAnnotation(AnnotatedMethod am)
/*     */   {
/* 432 */     JsonValue ann = (JsonValue)am.getAnnotation(JsonValue.class);
/*     */     
/* 434 */     return (ann != null) && (ann.value());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findSerializablePropertyName(AnnotatedField af)
/*     */   {
/* 446 */     JsonProperty pann = (JsonProperty)af.getAnnotation(JsonProperty.class);
/* 447 */     if (pann != null) {
/* 448 */       return pann.value();
/*     */     }
/*     */     
/*     */ 
/* 452 */     if ((af.hasAnnotation(JsonSerialize.class)) || (af.hasAnnotation(JsonView.class))) {
/* 453 */       return "";
/*     */     }
/* 455 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<? extends JsonDeserializer<?>> findDeserializer(Annotated a, BeanProperty property)
/*     */   {
/* 470 */     JsonDeserialize ann = (JsonDeserialize)a.getAnnotation(JsonDeserialize.class);
/* 471 */     if (ann != null) {
/* 472 */       Class<? extends JsonDeserializer<?>> deserClass = ann.using();
/* 473 */       if (deserClass != org.codehaus.jackson.map.JsonDeserializer.None.class) {
/* 474 */         return deserClass;
/*     */       }
/*     */     }
/*     */     
/* 478 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<? extends org.codehaus.jackson.map.KeyDeserializer> findKeyDeserializer(Annotated a)
/*     */   {
/* 484 */     JsonDeserialize ann = (JsonDeserialize)a.getAnnotation(JsonDeserialize.class);
/* 485 */     if (ann != null) {
/* 486 */       Class<? extends org.codehaus.jackson.map.KeyDeserializer> deserClass = ann.keyUsing();
/* 487 */       if (deserClass != org.codehaus.jackson.map.KeyDeserializer.None.class) {
/* 488 */         return deserClass;
/*     */       }
/*     */     }
/* 491 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated a)
/*     */   {
/* 497 */     JsonDeserialize ann = (JsonDeserialize)a.getAnnotation(JsonDeserialize.class);
/* 498 */     if (ann != null) {
/* 499 */       Class<? extends JsonDeserializer<?>> deserClass = ann.contentUsing();
/* 500 */       if (deserClass != org.codehaus.jackson.map.JsonDeserializer.None.class) {
/* 501 */         return deserClass;
/*     */       }
/*     */     }
/* 504 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> findDeserializationType(Annotated am, JavaType baseType, String propName)
/*     */   {
/* 512 */     JsonDeserialize ann = (JsonDeserialize)am.getAnnotation(JsonDeserialize.class);
/* 513 */     if (ann != null) {
/* 514 */       Class<?> cls = ann.as();
/* 515 */       if (cls != NoClass.class) {
/* 516 */         return cls;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 524 */     JsonClass oldAnn = (JsonClass)am.getAnnotation(JsonClass.class);
/* 525 */     if (oldAnn != null)
/*     */     {
/* 527 */       Class<?> cls = oldAnn.value();
/* 528 */       if (cls != NoClass.class) {
/* 529 */         return cls;
/*     */       }
/*     */     }
/* 532 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> findDeserializationKeyType(Annotated am, JavaType baseKeyType, String propName)
/*     */   {
/* 540 */     JsonDeserialize ann = (JsonDeserialize)am.getAnnotation(JsonDeserialize.class);
/* 541 */     if (ann != null) {
/* 542 */       Class<?> cls = ann.keyAs();
/* 543 */       if (cls != NoClass.class) {
/* 544 */         return cls;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 552 */     JsonKeyClass oldAnn = (JsonKeyClass)am.getAnnotation(JsonKeyClass.class);
/* 553 */     if (oldAnn != null)
/*     */     {
/* 555 */       Class<?> cls = oldAnn.value();
/* 556 */       if (cls != NoClass.class) {
/* 557 */         return cls;
/*     */       }
/*     */     }
/* 560 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> findDeserializationContentType(Annotated am, JavaType baseContentType, String propName)
/*     */   {
/* 569 */     JsonDeserialize ann = (JsonDeserialize)am.getAnnotation(JsonDeserialize.class);
/* 570 */     if (ann != null) {
/* 571 */       Class<?> cls = ann.contentAs();
/* 572 */       if (cls != NoClass.class) {
/* 573 */         return cls;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 580 */     JsonContentClass oldAnn = (JsonContentClass)am.getAnnotation(JsonContentClass.class);
/* 581 */     if (oldAnn != null) {
/* 582 */       Class<?> cls = oldAnn.value();
/* 583 */       if (cls != NoClass.class) {
/* 584 */         return cls;
/*     */       }
/*     */     }
/* 587 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findSettablePropertyName(AnnotatedMethod am)
/*     */   {
/* 605 */     JsonProperty pann = (JsonProperty)am.getAnnotation(JsonProperty.class);
/* 606 */     if (pann != null) {
/* 607 */       return pann.value();
/*     */     }
/* 609 */     JsonSetter ann = (JsonSetter)am.getAnnotation(JsonSetter.class);
/* 610 */     if (ann != null) {
/* 611 */       return ann.value();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 617 */     if ((am.hasAnnotation(JsonDeserialize.class)) || (am.hasAnnotation(JsonView.class))) {
/* 618 */       return "";
/*     */     }
/* 620 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean hasAnySetterAnnotation(AnnotatedMethod am)
/*     */   {
/* 630 */     return am.hasAnnotation(org.codehaus.jackson.annotate.JsonAnySetter.class);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean hasAnyGetterAnnotation(AnnotatedMethod am)
/*     */   {
/* 639 */     return am.hasAnnotation(org.codehaus.jackson.annotate.JsonAnyGetter.class);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean hasCreatorAnnotation(Annotated a)
/*     */   {
/* 649 */     return a.hasAnnotation(org.codehaus.jackson.annotate.JsonCreator.class);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findDeserializablePropertyName(AnnotatedField af)
/*     */   {
/* 661 */     JsonProperty pann = (JsonProperty)af.getAnnotation(JsonProperty.class);
/* 662 */     if (pann != null) {
/* 663 */       return pann.value();
/*     */     }
/*     */     
/*     */ 
/* 667 */     if ((af.hasAnnotation(JsonDeserialize.class)) || (af.hasAnnotation(JsonView.class))) {
/* 668 */       return "";
/*     */     }
/* 670 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String findPropertyNameForParam(AnnotatedParameter param)
/*     */   {
/* 682 */     if (param != null) {
/* 683 */       JsonProperty pann = (JsonProperty)param.getAnnotation(JsonProperty.class);
/* 684 */       if (pann != null) {
/* 685 */         return pann.value();
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 692 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected boolean _isIgnorable(Annotated a)
/*     */   {
/* 703 */     org.codehaus.jackson.annotate.JsonIgnore ann = (org.codehaus.jackson.annotate.JsonIgnore)a.getAnnotation(org.codehaus.jackson.annotate.JsonIgnore.class);
/* 704 */     return (ann != null) && (ann.value());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected TypeResolverBuilder<?> _findTypeResolver(MapperConfig<?> config, Annotated ann, JavaType baseType)
/*     */   {
/* 716 */     JsonTypeInfo info = (JsonTypeInfo)ann.getAnnotation(JsonTypeInfo.class);
/* 717 */     JsonTypeResolver resAnn = (JsonTypeResolver)ann.getAnnotation(JsonTypeResolver.class);
/* 718 */     TypeResolverBuilder<?> b; if (resAnn != null)
/*     */     {
/*     */ 
/*     */ 
/* 722 */       if (info == null) {
/* 723 */         return null;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 729 */       b = config.typeResolverBuilderInstance(ann, resAnn.value());
/*     */     } else {
/* 731 */       if ((info == null) || (info.use() == org.codehaus.jackson.annotate.JsonTypeInfo.Id.NONE)) {
/* 732 */         return null;
/*     */       }
/* 734 */       b = _constructStdTypeResolverBuilder();
/*     */     }
/*     */     
/* 737 */     JsonTypeIdResolver idResInfo = (JsonTypeIdResolver)ann.getAnnotation(JsonTypeIdResolver.class);
/* 738 */     org.codehaus.jackson.map.jsontype.TypeIdResolver idRes = idResInfo == null ? null : config.typeIdResolverInstance(ann, idResInfo.value());
/*     */     
/* 740 */     if (idRes != null) {
/* 741 */       idRes.init(baseType);
/*     */     }
/* 743 */     TypeResolverBuilder<?> b = b.init(info.use(), idRes);
/* 744 */     b = b.inclusion(info.include());
/* 745 */     b = b.typeProperty(info.property());
/* 746 */     return b;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected org.codehaus.jackson.map.jsontype.impl.StdTypeResolverBuilder _constructStdTypeResolverBuilder()
/*     */   {
/* 757 */     return new org.codehaus.jackson.map.jsontype.impl.StdTypeResolverBuilder();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\introspect\JacksonAnnotationIntrospector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */