package com.ibm.wsdl.extensions.http;

import com.ibm.wsdl.Constants;
import com.ibm.wsdl.util.xml.DOMUtils;
import java.io.PrintWriter;
import java.io.Serializable;
import javax.wsdl.Definition;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.ExtensionDeserializer;
import javax.wsdl.extensions.ExtensionRegistry;
import javax.wsdl.extensions.ExtensionSerializer;
import javax.wsdl.extensions.http.HTTPAddress;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class HTTPAddressSerializer
  implements ExtensionSerializer, ExtensionDeserializer, Serializable
{
  public static final long serialVersionUID = 1L;
  
  public void marshall(Class paramClass, QName paramQName, ExtensibilityElement paramExtensibilityElement, PrintWriter paramPrintWriter, Definition paramDefinition, ExtensionRegistry paramExtensionRegistry)
    throws WSDLException
  {
    HTTPAddress localHTTPAddress = (HTTPAddress)paramExtensibilityElement;
    if (localHTTPAddress != null)
    {
      String str = DOMUtils.getQualifiedValue("http://schemas.xmlsoap.org/wsdl/http/", "address", paramDefinition);
      paramPrintWriter.print("      <" + str);
      DOMUtils.printAttribute("location", localHTTPAddress.getLocationURI(), paramPrintWriter);
      Boolean localBoolean = localHTTPAddress.getRequired();
      if (localBoolean != null) {
        DOMUtils.printQualifiedAttribute(Constants.Q_ATTR_REQUIRED, localBoolean.toString(), paramDefinition, paramPrintWriter);
      }
      paramPrintWriter.println("/>");
    }
  }
  
  public ExtensibilityElement unmarshall(Class paramClass, QName paramQName, Element paramElement, Definition paramDefinition, ExtensionRegistry paramExtensionRegistry)
    throws WSDLException
  {
    HTTPAddress localHTTPAddress = (HTTPAddress)paramExtensionRegistry.createExtension(paramClass, paramQName);
    String str1 = DOMUtils.getAttribute(paramElement, "location");
    String str2 = DOMUtils.getAttributeNS(paramElement, "http://schemas.xmlsoap.org/wsdl/", "required");
    if (str1 != null) {
      localHTTPAddress.setLocationURI(str1);
    }
    if (str2 != null) {
      localHTTPAddress.setRequired(new Boolean(str2));
    }
    return localHTTPAddress;
  }
}


/* Location:              /Users/anandkum/Downloads/axis-wsdl4j-1.5.1.jar!/com/ibm/wsdl/extensions/http/HTTPAddressSerializer.class
 * Java compiler version: 2 (46.0)
 * JD-Core Version:       0.7.1
 */