/*    */ package com.netapp.asup.data.function.filter;
/*    */ 
/*    */ import com.netapp.asup.data.function.FunctionInputHandler;
/*    */ import java.util.HashMap;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class FilterInputHandler
/*    */   implements FunctionInputHandler<FilterInputImpl>
/*    */ {
/*    */   private static final String FILTER_INPUT = "filterInput";
/*    */   
/*    */   public GenericRecord handleInput(Schema schema, FilterInputImpl input)
/*    */   {
/* 23 */     Map<Utf8, GenericData.Array<GenericRecord>> output = new HashMap();
/*    */     
/* 25 */     GenericRecord inputGR = new GenericData.Record(schema);
/* 26 */     Schema filterInputArraySchema = schema.getField("filterInput").schema().getValueType();
/*    */     
/* 28 */     Map<String, List<FilterField>> filterMap = input.getFilterMap();
/*    */     
/* 30 */     GenericData.Array<GenericRecord> filterArray = null;
/* 31 */     List<FilterField> list = null;
/* 32 */     for (String path : filterMap.keySet())
/*    */     {
/* 34 */       list = (List)filterMap.get(path);
/*    */       
/* 36 */       filterArray = new GenericData.Array(list.size(), filterInputArraySchema);
/*    */       
/* 38 */       for (FilterField filterField : list) {
/* 39 */         filterArray.add(filterField.getObject(filterInputArraySchema.getElementType()));
/*    */       }
/* 41 */       output.put(new Utf8(path), filterArray);
/*    */     }
/* 43 */     inputGR.put("filterInput", output);
/* 44 */     return inputGR;
/*    */   }
/*    */   
/*    */   public FilterInputImpl handleInput(GenericRecord record)
/*    */   {
/* 49 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\filter\FilterInputHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */