/*    */ package com.netapp.asup.metamodel;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.data.exception.ARMARemoteCallException;
/*    */ import com.netapp.asup.data.util.HttpConnectionManager;
/*    */ import com.netapp.asup.data.util.HttpConnectionManager.HttpConnection;
/*    */ import com.netapp.asup.exception.ARMAConfigurationException;
/*    */ import com.netapp.asup.exception.ARMAMetaModelException;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import prefuse.data.Graph;
/*    */ import prefuse.data.io.DataIOException;
/*    */ import prefuse.data.io.GraphMLReader;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ServletConnector
/*    */   implements Connector
/*    */ {
/*    */   private static final String ARMA_META_MODEL = "arma/metamodel/";
/*    */   private final HttpConnectionManager manager;
/* 23 */   private static final AsupLogger logger = AsupLogger.getLogger(ServletConnector.class);
/*    */   
/*    */   public ServletConnector(String graphMlMapping)
/*    */     throws ARMAConfigurationException
/*    */   {
/* 28 */     this.manager = HttpConnectionManager.getInstance();
/*    */   }
/*    */   
/*    */   public Graph getMetaModel(String versionName) throws ARMAMetaModelException {
/* 32 */     Graph graph = getGraph(versionName);
/* 33 */     return graph;
/*    */   }
/*    */   
/*    */   public Graph getGraph(String versionName) throws ARMAMetaModelException {
/*    */     try {
/* 38 */       return getRequest(versionName, "arma/metamodel/");
/*    */     } catch (ARMARemoteCallException e) {
/* 40 */       throw new ARMAMetaModelException(logger, versionName, "Error in getting metamodeldata from server caused by :" + e.getMessage(), e);
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public Graph getRequest(String versionName, String url)
/*    */     throws ARMARemoteCallException, ARMAMetaModelException
/*    */   {
/* 49 */     GraphMLReader reader = new GraphMLReader();
/* 50 */     InputStream metaModelStream = null;
/*    */     try {
/* 52 */       metaModelStream = getMetaModelStream(versionName);
/* 53 */       return reader.readGraph(metaModelStream);
/*    */     } catch (DataIOException e) {
/* 55 */       throw new ARMAMetaModelException(logger, "GraphMl could not be read ", e);
/*    */     }
/*    */     finally {
/* 58 */       if (null != metaModelStream) {
/*    */         try {
/* 60 */           metaModelStream.close();
/*    */         } catch (IOException e) {
/* 62 */           new ARMAMetaModelException(logger, versionName, "Unable to close request stream caused by :" + e.getMessage(), e);
/*    */         }
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public InputStream getMetaModelStream(String versionName)
/*    */     throws ARMAMetaModelException
/*    */   {
/* 74 */     HttpConnectionManager.HttpConnection connection = null;
/* 75 */     InputStream inputStream = null;
/*    */     try {
/* 77 */       connection = this.manager.getConnection(versionName, "arma/metamodel/", "POST");
/*    */       
/* 79 */       return connection.getRequest(versionName);
/*    */     }
/*    */     catch (ARMARemoteCallException e) {
/* 82 */       throw new ARMAMetaModelException(logger, versionName, "Error in getting metamodeldata from server caused by :" + e.getMessage(), e);
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\metamodel\ServletConnector.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */