/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.annotation.MethodLocatable;
/*     */ import com.sun.xml.bind.v2.model.core.RegistryInfo;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import java.util.LinkedHashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import javax.xml.bind.annotation.XmlElementDecl;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class RegistryInfoImpl<T, C, F, M>
/*     */   implements Locatable, RegistryInfo<T, C>
/*     */ {
/*     */   final C registryClass;
/*     */   private final Locatable upstream;
/*     */   private final Navigator<T, C, F, M> nav;
/*  34 */   private final Set<TypeInfo<T, C>> references = new LinkedHashSet();
/*     */   
/*     */ 
/*     */ 
/*     */   RegistryInfoImpl(ModelBuilder<T, C, F, M> builder, Locatable upstream, C registryClass)
/*     */   {
/*  40 */     this.nav = builder.nav;
/*  41 */     this.registryClass = registryClass;
/*  42 */     this.upstream = upstream;
/*  43 */     builder.registries.put(getPackageName(), this);
/*     */     
/*  45 */     if (this.nav.getDeclaredField(registryClass, "_useJAXBProperties") != null)
/*     */     {
/*     */ 
/*  48 */       builder.reportError(new IllegalAnnotationException(Messages.MISSING_JAXB_PROPERTIES.format(new Object[] { getPackageName() }), this));
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*  53 */       return;
/*     */     }
/*     */     
/*  56 */     for (M m : this.nav.getDeclaredMethods(registryClass)) {
/*  57 */       XmlElementDecl em = (XmlElementDecl)builder.reader.getMethodAnnotation(XmlElementDecl.class, m, this);
/*     */       
/*     */ 
/*  60 */       if (em == null) {
/*  61 */         if (this.nav.getMethodName(m).startsWith("create"))
/*     */         {
/*  63 */           this.references.add(builder.getTypeInfo(this.nav.getReturnType(m), new MethodLocatable(this, m, this.nav)));
/*     */         }
/*     */       }
/*     */       else
/*     */       {
/*     */         ElementInfoImpl<T, C, F, M> ei;
/*     */         
/*     */ 
/*     */         try
/*     */         {
/*  73 */           ei = builder.createElementInfo(this, m);
/*     */         } catch (IllegalAnnotationException e) {
/*  75 */           builder.reportError(e); }
/*  76 */         continue;
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*  81 */         builder.typeInfoSet.add(ei, builder);
/*  82 */         this.references.add(ei);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*  87 */   public Locatable getUpstream() { return this.upstream; }
/*     */   
/*     */   public Location getLocation()
/*     */   {
/*  91 */     return this.nav.getClassLocation(this.registryClass);
/*     */   }
/*     */   
/*     */   public Set<TypeInfo<T, C>> getReferences() {
/*  95 */     return this.references;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String getPackageName()
/*     */   {
/* 102 */     return this.nav.getPackageName(this.registryClass);
/*     */   }
/*     */   
/*     */   public C getClazz() {
/* 106 */     return (C)this.registryClass;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\RegistryInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */