/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class AssociationMap<XmlNode>
/*     */ {
/*     */   static final class Entry<XmlNode>
/*     */   {
/*     */     private XmlNode element;
/*     */     private Object inner;
/*     */     private Object outer;
/*     */     
/*     */     public XmlNode element()
/*     */     {
/*  49 */       return (XmlNode)this.element;
/*     */     }
/*     */     
/*  52 */     public Object inner() { return this.inner; }
/*     */     
/*     */     public Object outer() {
/*  55 */       return this.outer;
/*     */     }
/*     */   }
/*     */   
/*  59 */   private final Map<XmlNode, Entry<XmlNode>> byElement = new HashMap();
/*  60 */   private final Map<Object, Entry<XmlNode>> byPeer = new HashMap();
/*  61 */   private final Set<XmlNode> usedNodes = new HashSet();
/*     */   
/*     */   public void addInner(XmlNode element, Object inner)
/*     */   {
/*  65 */     Entry<XmlNode> e = (Entry)this.byElement.get(element);
/*  66 */     if (e != null) {
/*  67 */       if (e.inner != null)
/*  68 */         this.byPeer.remove(e.inner);
/*  69 */       e.inner = inner;
/*     */     } else {
/*  71 */       e = new Entry();
/*  72 */       e.element = element;
/*  73 */       e.inner = inner;
/*     */     }
/*     */     
/*  76 */     this.byElement.put(element, e);
/*     */     
/*  78 */     Entry<XmlNode> old = (Entry)this.byPeer.put(inner, e);
/*  79 */     if (old != null) {
/*  80 */       if (old.outer != null)
/*  81 */         this.byPeer.remove(old.outer);
/*  82 */       if (old.element != null) {
/*  83 */         this.byElement.remove(old.element);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void addOuter(XmlNode element, Object outer) {
/*  89 */     Entry<XmlNode> e = (Entry)this.byElement.get(element);
/*  90 */     if (e != null) {
/*  91 */       if (e.outer != null)
/*  92 */         this.byPeer.remove(e.outer);
/*  93 */       e.outer = outer;
/*     */     } else {
/*  95 */       e = new Entry();
/*  96 */       e.element = element;
/*  97 */       e.outer = outer;
/*     */     }
/*     */     
/* 100 */     this.byElement.put(element, e);
/*     */     
/* 102 */     Entry<XmlNode> old = (Entry)this.byPeer.put(outer, e);
/* 103 */     if (old != null) {
/* 104 */       old.outer = null;
/*     */       
/* 106 */       if (old.inner == null)
/*     */       {
/* 108 */         this.byElement.remove(old.element); }
/*     */     }
/*     */   }
/*     */   
/*     */   public void addUsed(XmlNode n) {
/* 113 */     this.usedNodes.add(n);
/*     */   }
/*     */   
/*     */   public Entry<XmlNode> byElement(Object e) {
/* 117 */     return (Entry)this.byElement.get(e);
/*     */   }
/*     */   
/*     */   public Entry<XmlNode> byPeer(Object o) {
/* 121 */     return (Entry)this.byPeer.get(o);
/*     */   }
/*     */   
/*     */   public Object getInnerPeer(XmlNode element) {
/* 125 */     Entry e = byElement(element);
/* 126 */     if (e == null) return null;
/* 127 */     return e.inner;
/*     */   }
/*     */   
/*     */   public Object getOuterPeer(XmlNode element) {
/* 131 */     Entry e = byElement(element);
/* 132 */     if (e == null) return null;
/* 133 */     return e.outer;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\AssociationMap.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */