/*    */ package com.sun.xml.bind.v2.runtime.property;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*    */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementPropertyInfo;
/*    */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeRef;
/*    */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*    */ import com.sun.xml.bind.v2.runtime.Name;
/*    */ import com.sun.xml.bind.v2.runtime.NameBuilder;
/*    */ import com.sun.xml.bind.v2.runtime.Transducer;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.ListTransducedAccessorImpl;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.LeafPropertyLoader;
/*    */ import com.sun.xml.bind.v2.util.QNameMap;
/*    */ import java.io.IOException;
/*    */ import java.util.List;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class ListElementProperty<BeanT, ListT, ItemT>
/*    */   extends ArrayProperty<BeanT, ListT, ItemT>
/*    */ {
/*    */   private final Name tagName;
/*    */   private final TransducedAccessor<BeanT> xacc;
/*    */   
/*    */   public ListElementProperty(JAXBContextImpl grammar, RuntimeElementPropertyInfo prop)
/*    */   {
/* 39 */     super(grammar, prop);
/*    */     
/* 41 */     assert (prop.isValueList());
/* 42 */     assert (prop.getTypes().size() == 1);
/* 43 */     RuntimeTypeRef ref = (RuntimeTypeRef)prop.getTypes().get(0);
/*    */     
/* 45 */     this.tagName = grammar.nameBuilder.createElementName(ref.getTagName());
/*    */     
/*    */ 
/* 48 */     Transducer xducer = ref.getTransducer();
/*    */     
/* 50 */     this.xacc = new ListTransducedAccessorImpl(xducer, this.acc, this.lister);
/*    */   }
/*    */   
/*    */   public PropertyKind getKind() {
/* 54 */     return PropertyKind.ELEMENT;
/*    */   }
/*    */   
/*    */   public void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> handlers) {
/* 58 */     handlers.put(this.tagName, new ChildLoader(new LeafPropertyLoader(this.xacc), null));
/*    */   }
/*    */   
/*    */   public void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/* 62 */     ListT list = this.acc.get(o);
/*    */     
/* 64 */     if (list != null) {
/* 65 */       if (this.xacc.useNamespace()) {
/* 66 */         w.startElement(this.tagName, null);
/* 67 */         this.xacc.declareNamespace(o, w);
/* 68 */         w.endNamespaceDecls(list);
/* 69 */         w.endAttributes();
/* 70 */         this.xacc.writeText(w, o, this.fieldName);
/* 71 */         w.endElement();
/*    */       } else {
/* 73 */         this.xacc.writeLeafElement(w, this.tagName, o, this.fieldName);
/*    */       }
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\ListElementProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */