/*    */ package org.codehaus.jackson.map.deser;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import org.codehaus.jackson.JsonParser;
/*    */ import org.codehaus.jackson.JsonProcessingException;
/*    */ import org.codehaus.jackson.map.DeserializationConfig.Feature;
/*    */ import org.codehaus.jackson.map.DeserializationContext;
/*    */ import org.codehaus.jackson.map.JsonDeserializer;
/*    */ import org.codehaus.jackson.map.TypeDeserializer;
/*    */ import org.codehaus.jackson.type.JavaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class AbstractDeserializer
/*    */   extends JsonDeserializer<Object>
/*    */ {
/*    */   protected final JavaType _baseType;
/*    */   
/*    */   public AbstractDeserializer(JavaType bt)
/*    */   {
/* 27 */     this._baseType = bt;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public Object deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 38 */     switch (jp.getCurrentToken())
/*    */     {
/*    */ 
/*    */ 
/*    */     case VALUE_STRING: 
/* 43 */       return jp.getText();
/*    */     
/*    */ 
/*    */     case VALUE_NUMBER_INT: 
/* 47 */       if (ctxt.isEnabled(DeserializationConfig.Feature.USE_BIG_INTEGER_FOR_INTS)) {
/* 48 */         return jp.getBigIntegerValue();
/*    */       }
/* 50 */       return Integer.valueOf(jp.getIntValue());
/*    */     
/*    */ 
/*    */     case VALUE_NUMBER_FLOAT: 
/* 54 */       if (ctxt.isEnabled(DeserializationConfig.Feature.USE_BIG_DECIMAL_FOR_FLOATS)) {
/* 55 */         return jp.getDecimalValue();
/*    */       }
/* 57 */       return Double.valueOf(jp.getDoubleValue());
/*    */     
/*    */     case VALUE_TRUE: 
/* 60 */       return Boolean.TRUE;
/*    */     case VALUE_FALSE: 
/* 62 */       return Boolean.FALSE;
/*    */     case VALUE_EMBEDDED_OBJECT: 
/* 64 */       return jp.getEmbeddedObject();
/*    */     
/*    */     case VALUE_NULL: 
/* 67 */       return null;
/*    */     
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */     case START_ARRAY: 
/* 77 */       return typeDeserializer.deserializeTypedFromAny(jp, ctxt);
/*    */     }
/*    */     
/*    */     
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 89 */     return typeDeserializer.deserializeTypedFromObject(jp, ctxt);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public Object deserialize(JsonParser jp, DeserializationContext ctxt)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 97 */     throw ctxt.instantiationException(this._baseType.getRawClass(), "abstract types can only be instantiated with additional type information");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\AbstractDeserializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */