/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.annotation.Annotation;
/*    */ import java.lang.reflect.AnnotatedElement;
/*    */ import org.hibernate.annotations.common.reflection.AnnotationReader;
/*    */ import org.hibernate.annotations.common.reflection.XAnnotatedElement;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ abstract class JavaXAnnotatedElement
/*    */   implements XAnnotatedElement
/*    */ {
/*    */   private AnnotationReader annotationReader;
/*    */   private final JavaReflectionManager factory;
/*    */   private final AnnotatedElement annotatedElement;
/*    */   
/*    */   public JavaXAnnotatedElement(AnnotatedElement annotatedElement, JavaReflectionManager factory)
/*    */   {
/* 23 */     this.factory = factory;
/* 24 */     this.annotatedElement = annotatedElement;
/*    */   }
/*    */   
/*    */   protected JavaReflectionManager getFactory() {
/* 28 */     return this.factory;
/*    */   }
/*    */   
/*    */   private AnnotationReader getAnnotationReader() {
/* 32 */     if (this.annotationReader == null) {
/* 33 */       this.annotationReader = this.factory.buildAnnotationReader(this.annotatedElement);
/*    */     }
/* 35 */     return this.annotationReader;
/*    */   }
/*    */   
/*    */   public <T extends Annotation> T getAnnotation(Class<T> annotationType) {
/* 39 */     return getAnnotationReader().getAnnotation(annotationType);
/*    */   }
/*    */   
/*    */   public <T extends Annotation> boolean isAnnotationPresent(Class<T> annotationType) {
/* 43 */     return getAnnotationReader().isAnnotationPresent(annotationType);
/*    */   }
/*    */   
/*    */   public Annotation[] getAnnotations() {
/* 47 */     return getAnnotationReader().getAnnotations();
/*    */   }
/*    */   
/*    */   AnnotatedElement toAnnotatedElement() {
/* 51 */     return this.annotatedElement;
/*    */   }
/*    */   
/*    */   public boolean equals(Object obj)
/*    */   {
/* 56 */     if (!(obj instanceof JavaXAnnotatedElement)) return false;
/* 57 */     JavaXAnnotatedElement other = (JavaXAnnotatedElement)obj;
/*    */     
/* 59 */     return this.annotatedElement.equals(other.toAnnotatedElement());
/*    */   }
/*    */   
/*    */   public int hashCode()
/*    */   {
/* 64 */     return this.annotatedElement.hashCode();
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 69 */     return this.annotatedElement.toString();
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXAnnotatedElement.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */