package prefuse.action.animate;

import java.util.Iterator;
import prefuse.Visualization;
import prefuse.action.ItemAction;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.StartVisiblePredicate;

public class AxisLabelAnimator
  extends ItemAction
{
  protected AxisLabelAnimator() {}
  
  public AxisLabelAnimator(String paramString)
  {
    super(paramString);
  }
  
  public void run(double paramDouble)
  {
    if (paramDouble == 0.0D) {
      setup();
    } else if (paramDouble == 1.0D) {
      finish();
    } else {
      super.run(paramDouble);
    }
    TupleSet localTupleSet = this.m_vis.getGroup(this.m_group);
    localTupleSet.putClientProperty("frac", new Double(paramDouble));
  }
  
  private void setup()
  {
    Iterator localIterator = this.m_vis.visibleItems(this.m_group);
    VisualItem localVisualItem;
    int i;
    int j;
    int k;
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isStartVisible())
      {
        i = localVisualItem.getEndFillColor();
        j = localVisualItem.getEndStrokeColor();
        k = localVisualItem.getEndTextColor();
        localVisualItem.setStartFillColor(ColorLib.setAlpha(i, 0));
        localVisualItem.setStartStrokeColor(ColorLib.setAlpha(j, 0));
        localVisualItem.setStartTextColor(ColorLib.setAlpha(k, 0));
        localVisualItem.setStartVisible(true);
      }
      process(localVisualItem, 0.0D);
    }
    localIterator = this.m_vis.items(this.m_group, StartVisiblePredicate.TRUE);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isEndVisible())
      {
        i = localVisualItem.getStartFillColor();
        j = localVisualItem.getStartStrokeColor();
        k = localVisualItem.getStartTextColor();
        localVisualItem.setEndFillColor(ColorLib.setAlpha(i, 0));
        localVisualItem.setEndStrokeColor(ColorLib.setAlpha(j, 0));
        localVisualItem.setEndTextColor(ColorLib.setAlpha(k, 0));
        localVisualItem.setVisible(true);
        process(localVisualItem, 0.0D);
      }
    }
  }
  
  private void finish()
  {
    Iterator localIterator = this.m_vis.items(this.m_group, StartVisiblePredicate.TRUE);
    VisualItem localVisualItem;
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isEndVisible())
      {
        localVisualItem.setVisible(false);
        localVisualItem.setStartVisible(false);
      }
    }
    localIterator = this.m_vis.visibleItems(this.m_group);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      process(localVisualItem, 1.0D);
      localVisualItem.setStartFillColor(localVisualItem.getEndFillColor());
      localVisualItem.setStartTextColor(localVisualItem.getEndTextColor());
      localVisualItem.setStartStrokeColor(localVisualItem.getEndStrokeColor());
    }
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    double d = paramVisualItem.getStartX();
    paramVisualItem.setX(d + paramDouble * (paramVisualItem.getEndX() - d));
    d = paramVisualItem.getStartY();
    paramVisualItem.setY(d + paramDouble * (paramVisualItem.getEndY() - d));
    d = paramVisualItem.getDouble(VisualItem.STARTX2);
    d += paramDouble * (paramVisualItem.getDouble(VisualItem.ENDX2) - d);
    paramVisualItem.setDouble(VisualItem.X2, d);
    d = paramVisualItem.getDouble(VisualItem.STARTY2);
    d += paramDouble * (paramVisualItem.getDouble(VisualItem.ENDY2) - d);
    paramVisualItem.setDouble(VisualItem.Y2, d);
    int i = ColorLib.interp(paramVisualItem.getStartStrokeColor(), paramVisualItem.getEndStrokeColor(), paramDouble);
    paramVisualItem.setStrokeColor(i);
    int j = ColorLib.interp(paramVisualItem.getStartTextColor(), paramVisualItem.getEndTextColor(), paramDouble);
    paramVisualItem.setTextColor(j);
    int k = ColorLib.interp(paramVisualItem.getStartFillColor(), paramVisualItem.getEndFillColor(), paramDouble);
    paramVisualItem.setFillColor(k);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\animate\AxisLabelAnimator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */