package prefuse.data.expression;

import prefuse.data.Tuple;

public class NotPredicate
  extends AbstractPredicate
{
  private Predicate m_predicate;
  
  public NotPredicate(Predicate paramPredicate)
  {
    this.m_predicate = paramPredicate;
  }
  
  public Predicate getPredicate()
  {
    return this.m_predicate;
  }
  
  public boolean getBoolean(Tuple paramTuple)
  {
    return !this.m_predicate.getBoolean(paramTuple);
  }
  
  public void visit(ExpressionVisitor paramExpressionVisitor)
  {
    paramExpressionVisitor.visitExpression(this);
    paramExpressionVisitor.down();
    this.m_predicate.visit(paramExpressionVisitor);
    paramExpressionVisitor.up();
  }
  
  public String toString()
  {
    return "NOT " + this.m_predicate.toString();
  }
  
  protected void addChildListeners()
  {
    this.m_predicate.addExpressionListener(this);
  }
  
  protected void removeChildListeners()
  {
    this.m_predicate.removeExpressionListener(this);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\NotPredicate.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */